//+------------------------------------------------------------------+
//|                                                   i-DayRange.mq4 |
//|                                             . aka KimIV |
//|                                              http://www.kimiv.ru |
//|                                                                  |
//|  17.11.2005                            |
//|  09.10.2006    CW   MaxRange,     |
//|                 .         |
//|  28.03.2007    avtotorg@list.ru       |
//|                    .                |
//+------------------------------------------------------------------+
//(.):         .
//    :
//  3 -       extern int AverageDayNumber 
//                         
//  4 -       extern int AverageDayNumber 
//                         
//  5 -       extern int AverageDayNumber  
//      Comment:
// -       extern int AverageDayNumber  
// -              extern int AverageDayNumber 
//   :
// -                                        - 00.00   (GMT+2)
// -                                  - 07.00   (GMT+2)
// -   ( - ) - 14.00   (GMT+2)
// -                                                 - 00.00   (GMT+2)

#property indicator_chart_window
#property indicator_buffers 6

#property indicator_color1 SteelBlue
#property indicator_style1 1
#property indicator_width1 2

#property indicator_color2 SteelBlue
#property indicator_style2 1
#property indicator_width2 2

#property indicator_color3 LightSlateGray
#property indicator_style3 0
#property indicator_width3 1

#property indicator_color4 Red
#property indicator_style4 1
#property indicator_width4 2

#property indicator_color5 Red
#property indicator_style5 1
#property indicator_width5 2

#property indicator_color6 White
#property indicator_style6 0
#property indicator_width6 1



//-------    -------------------------------
//Sart
extern int    AverageDayNumber = 60; //        
       double AverageVal;
static int    DayCurrent;
//
extern int   NumberOfDays = 5;      //   (0-)
extern int   MaxRange     = 300;    //  
extern bool  ShowContinue = True;   //   
extern bool  ShowPrice    = false;  //   
extern bool  ShowComment  = false;  //        

extern color clFont       = White;  //  
extern int   SizeFont     = 10;     //  
extern int   OffSet       = 10;     // 

double shifthigh[];
double shiftlow[];
double shiftavercurent[];

double shifthighAver[];
double shiftlowAver[];
double shiftaveraver[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {
  SetIndexBuffer   (0, shifthigh);
  SetIndexDrawBegin(0, 0);
  SetIndexLabel    (0, "Up Channel");
  SetIndexStyle    (0, DRAW_LINE);

  SetIndexBuffer   (1, shiftlow);
  SetIndexDrawBegin(1, 0);
  SetIndexLabel    (1, "Down Channel");
  SetIndexStyle    (1, DRAW_LINE);

  SetIndexBuffer   (2, shiftavercurent);
  SetIndexDrawBegin(2, 0);
  SetIndexLabel    (2, "Average Current");
  SetIndexStyle    (2, DRAW_LINE, 0,1);

  SetIndexBuffer   (3, shifthighAver);
  SetIndexDrawBegin(3, 0);
  SetIndexLabel    (3, "Average Up Channel");
  SetIndexStyle    (3, DRAW_LINE, 0,1);
  
  SetIndexBuffer   (4, shiftlowAver);
  SetIndexDrawBegin(4, 0);
  SetIndexLabel    (4, "Average Down Channel");
  SetIndexStyle    (4, DRAW_LINE, 0,1);
  
  SetIndexBuffer   (5, shiftaveraver);
  SetIndexDrawBegin(5, 0);
  SetIndexLabel    (5, "Average of Average Channel");
  SetIndexStyle    (5, DRAW_LINE, 0,1);
  
  AverageVal= NormalizeDouble((iMA(Symbol(), PERIOD_D1,AverageDayNumber, 0, MODE_SMA, PRICE_HIGH, 1)
                              -iMA(Symbol(), PERIOD_D1,AverageDayNumber, 0, MODE_SMA, PRICE_LOW, 1))/Point,0);
//-----------------------------------------------------------------------------------------------------------
  VlineInit();
}
//-----------------------------------------------------------------------------------------------------------
void VlineInit()
{
string String = "yyyy.mm.dd hh:mi";
String = TimeToStr(TimeCurrent());

String = StringSetChar(String,11,'0'); //hh
String = StringSetChar(String,12,'0');

String = StringSetChar(String,14,'0'); //mi
String = StringSetChar(String,15,'0');

datetime DayStart   = StrToTime(String); 
datetime DayEnd     = DayStart+86400;

String = StringSetChar(String,11,'0'); //hh
String = StringSetChar(String,12,'7');

String = StringSetChar(String,14,'0'); //mi
String = StringSetChar(String,15,'0');

datetime EurSesStart = StrToTime(String);

String = StringSetChar(String,11,'1'); //hh
String = StringSetChar(String,12,'4');
String = StringSetChar(String,14,'0'); //mi
String = StringSetChar(String,15,'0');

datetime UsaSesStart = StrToTime(String);

String = StringSetChar(String,11,'0'); //hh
String = StringSetChar(String,12,'0');

if (ObjectFind("DayStart"+String)<0)    ObjectCreate("DayStart"+String,   OBJ_VLINE,0,DayStart,0);
if (ObjectFind("DayEnd"+String)  <0)    ObjectCreate("DayEnd"+String,     OBJ_VLINE,0,DayEnd,0);
if (ObjectFind("EurSesStart"+String)<0) ObjectCreate("EurSesStart"+String,OBJ_VLINE,0,EurSesStart,0);
if (ObjectFind("UsaSesStart"+String)<0) ObjectCreate("UsaSesStart"+String,OBJ_VLINE,0,UsaSesStart,0);
ObjectSet("DayStart"+String   ,OBJPROP_COLOR,White);
ObjectSet("DayEnd"+String     ,OBJPROP_COLOR,White);
ObjectSet("EurSesStart"+String,OBJPROP_COLOR,White);
ObjectSet("UsaSesStart"+String,OBJPROP_COLOR,White);

ObjectSet("DayStart"+String   ,OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("DayEnd"+String     ,OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("EurSesStart"+String,OBJPROP_STYLE,STYLE_DOT);
ObjectSet("UsaSesStart"+String,OBJPROP_STYLE,STYLE_DOT);
//------------------------------------------------------------------------------------------------------------------  
DayCurrent = TimeDayOfYear(TimeCurrent());  
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit() {
  ObjectDelete("UpPrice");
  ObjectDelete("DnPrice");
  ObjectDelete("UpAveragePrice");
  ObjectDelete("DnAveragePrice");
  ObjectDelete("AverageCurrent");
  ObjectDelete("AverageofAverageChannel");
//  ObjectsDeleteAll(EMPTY,OBJ_VLINE);
  Comment("");
}

//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+ 
void start() {
  datetime dt=TimeCurrent();
  if (TimeDayOfYear(dt) != DayCurrent) VlineInit();
  double   HighLine=0, LowLine=0, AverLine=0;
  double   AverHighLine=0, AverLowLine = 0,AverAverLine=0;
  int      i, j, kb;

//--------------------------------------------------------------------
  for (i=NumberBar(); i>=0; i--)
  {
    if (TimeHour(Time[i])==0 && TimeMinute(Time[i])==0)
     {
      HighLine=iHigh(Symbol(),0,i); 
      LowLine=iLow(Symbol(),0,i);
     }
     else
     {
      if (MaxRange<=0 || MaxRange*Point>HighLine-LowLine)
       {
        if (iHigh(NULL,0,i)>HighLine) HighLine=iHigh(NULL,0,i);
        if (iLow(NULL,0,i)<LowLine) LowLine=iLow(NULL,0,i);
       }
     }
    AverLine=LowLine+(HighLine-LowLine)/2; 
    AverHighLine = LowLine + AverageVal*Point; AverLowLine=HighLine-AverageVal*Point;
    AverAverLine = AverLowLine+(AverHighLine-AverLowLine)/2;
    kb=(StrToTime(TimeToStr(Time[0], TIME_DATE)+" 23:59")-Time[0])/Period()/60;
    if (i==0 && ShowContinue)
     {
      SetIndexShift(0, kb);
      SetIndexShift(1, kb);
      SetIndexShift(2, kb);

      SetIndexShift(3, kb);
      SetIndexShift(4, kb);
      
      for (j=kb; j>=0; j--)
       {
        shifthigh[j]=HighLine; shiftlowAver [j]=AverLowLine;
        shiftlow [j]=LowLine;  shifthighAver[j]=AverHighLine;
        shiftavercurent[j]=AverLine;
        shiftaveraver[j]=AverAverLine;
       }
     }
    shifthigh[i+kb]=HighLine; shiftlowAver[i+kb] =AverLowLine;
    shiftlow [i+kb]=LowLine;  shifthighAver[i+kb]=AverHighLine;
    shiftavercurent[i+kb]=AverLine;
    shiftaveraver[i+kb]=AverAverLine;
    if (i==0 && ShowPrice)
     {
      DrawPrices(dt, "Price",  HighLine   , LowLine   );
      DrawPrice (dt, "AverageCurrent", AverLine );
      
      DrawPrices(dt, "AveragePrice", AverHighLine,AverLowLine);
      DrawPrice (dt, "AverageofAverageChannel", AverAverLine );
     }
  }
    if (ShowComment)
     {
      Comment("  :                                    "+DoubleToStr((HighLine-LowLine)/Point,0)+" ."+"\n" +
          "     "+DoubleToStr(AverageDayNumber,0)+" : "+DoubleToStr(AverageVal,0)+" ."+
          "( "+DoubleToStr(AverageVal-(HighLine-LowLine)/Point,0)+" )"+"\n"+
          "/:                                                "+DoubleToStr((HighLine-LowLine)/Point/AverageVal,2));
     }
}

//+------------------------------------------------------------------+
//|                                   |
//| :                                                       |
//|   dt -                                           |
//|   no -                                        |
//|   up -                                      |
//|   dn -                                       |
//+------------------------------------------------------------------+
void DrawPrices(datetime dt, string no, double up, double dn) {
  if (ObjectFind("Up"+no)<0) ObjectCreate("Up"+no, OBJ_TEXT, 0, 0,0);
  ObjectSet("Up"+no, OBJPROP_TIME1   , dt);
  ObjectSet("Up"+no, OBJPROP_PRICE1  , up+(OffSet+SizeFont)*Point);
  ObjectSet("Up"+no, OBJPROP_COLOR   , clFont);
  ObjectSet("Up"+no, OBJPROP_FONTSIZE, SizeFont);
  ObjectSetText("Up"+no, DoubleToStr(up, Digits));

  if (ObjectFind("Dn"+no)<0) ObjectCreate("Dn"+no, OBJ_TEXT, 0, 0,0);
  ObjectSet("Dn"+no, OBJPROP_TIME1   , dt);
  ObjectSet("Dn"+no, OBJPROP_PRICE1  , dn-OffSet*Point);
  ObjectSet("Dn"+no, OBJPROP_COLOR   , clFont);
  ObjectSet("Dn"+no, OBJPROP_FONTSIZE, SizeFont);
  ObjectSetText("Dn"+no, DoubleToStr(dn, Digits));
}
void DrawPrice(datetime dt, string no, double up) {
  if (ObjectFind(no)<0) ObjectCreate(no, OBJ_TEXT, 0, 0,0);
  ObjectSet(no, OBJPROP_TIME1   , dt);
  ObjectSet(no, OBJPROP_PRICE1  , up+(OffSet+SizeFont)*Point);
  ObjectSet(no, OBJPROP_COLOR   , clFont);
  ObjectSet(no, OBJPROP_FONTSIZE, SizeFont);
  ObjectSetText(no, DoubleToStr(up, Digits));
}

//+------------------------------------------------------------------+ 
//|                                               |
//+------------------------------------------------------------------+ 
int NumberBar() {
  int nd=0, i=0;

  while (nd<NumberOfDays) {
    i++;
    if (TimeHour(Time[i])==0 && TimeMinute(Time[i])==0) nd++;
  }
  return(i);
}
//+------------------------------------------------------------------+

